﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using PACNET;

namespace _87k_ai {
    public partial class Form1 : Form {

        public Form1() {
            InitializeComponent();
        }

        //[DllImport("PACSDK.dll", EntryPoint = "pac_ReadAISensorSerialNumber")]
        //[return: MarshalAs(UnmanagedType.I1)]
        //public static extern bool ReadAISensorSerialNumber(IntPtr hPort, int iAddrSlot, int port, int iindex,[Out] byte[] SNstring, int Buff_Len);

        private void button_readAI_Click(object sender, EventArgs e) {
            IntPtr hPort = PACNET.UART.Open("");
            float f_AIValue=0;

            int i_slot = Convert.ToInt16(comboBox_slot.Text);
            int i_port = Convert.ToInt16(comboBox_port.Text);
            int i_readChannel = Convert.ToInt16(textBox_channelNum.Text);
            int i_totalChannel = Convert.ToInt16(textBox_totalChannel.Text);
            byte[] ba_temp = new byte[20];

            PACNET.PAC_IO.ReadAI(hPort, PACNET.PAC_IO.PAC_DAISY_CHAIN_WIRING_MODULE_PORT(i_slot, i_port), i_readChannel, i_totalChannel, ref f_AIValue);
            textBox_AIValue.Text = f_AIValue.ToString();

            PACNET.PAC_IO.ReadAISensorSerialNumber(hPort, i_slot, i_port, i_readChannel, ba_temp, 20);
            textBox_sersorSN.Text = System.Text.Encoding.Default.GetString(ba_temp,0,20);

            PACNET.UART.Close(hPort);
        }

        private void button_readAIAll_Click(object sender, EventArgs e) {
            IntPtr hPort = PACNET.UART.Open("");
            float[] fa_AIValue = new float[20];

            int i_slot = Convert.ToInt16(comboBox_slot.Text);
            int i_port = Convert.ToInt16(comboBox_port.Text);
            int i_readChannel = Convert.ToInt16(textBox_channelNum.Text);
            int i_totalChannel = Convert.ToInt16(textBox_totalChannel.Text);
            int i_len = 0;
            byte[] ba_temp = new byte[20];
            string s_temp = "";
            int i_endindex = 0;

            PACNET.PAC_IO.ReadAIAllExt(hPort, PACNET.PAC_IO.PAC_DAISY_CHAIN_WIRING_MODULE_PORT(i_slot, i_port), fa_AIValue, 20, ref i_len);
            for (int i = 0; i < i_totalChannel; i++) {
                PACNET.PAC_IO.ReadAISensorSerialNumber(hPort, i_slot, i_port, i, ba_temp, 20);
                for (int j = 0; j < 20; j++) {
                    if (ba_temp[j] == 0)  {
                        i_endindex = j;
                        break;
                    }
                }
                
                s_temp = System.Text.Encoding.Default.GetString(ba_temp, 0, i_endindex);
                Console.WriteLine("channel " + i + " ,value : " + fa_AIValue[i] + " [ " + s_temp + " ]");
            }

            PACNET.UART.Close(hPort);
        }

    }
}