﻿Imports System.ComponentModel
Imports System.IO
Imports System.Text
Imports System.Runtime.InteropServices
Imports PACNET

Public Class Form1

    

    Private Sub Button_readAllAI_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_readAIAll.Click
        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim fa_AIValue(19) As Single

        Dim i_slot As Integer = Convert.ToInt16(comboBox_slot.Text)
        Dim i_port As Integer = Convert.ToInt16(comboBox_port.Text)
        Dim i_readChannel As Integer = Convert.ToInt16(textBox_channelNum.Text)
        Dim i_totalChannel As Integer = Convert.ToInt16(textBox_totalChannel.Text)
        Dim i_len As Integer = 0
        Dim ba_temp(19) As Byte
        Dim s_temp As String = ""
        Dim i_endindex As Integer = 0

        PACNET.PAC_IO.ReadAIAllExt(hPort, PACNET.PAC_IO.PAC_DAISY_CHAIN_WIRING_MODULE_PORT(i_slot, i_port), fa_AIValue, 20, i_len)
        For i As Integer = 0 To i_totalChannel - 1
            PACNET.PAC_IO.ReadAISensorSerialNumber(hPort, i_slot, i_port, i, ba_temp, 20)
            For j As Integer = 0 To 19
                If ba_temp(j) = 0 Then
                    i_endindex = j
                    Exit For
                End If
            Next j

            s_temp = System.Text.Encoding.Default.GetString(ba_temp, 0, i_endindex)
            Console.WriteLine("channel " & i & " ,value : " & fa_AIValue(i) & " [ " & s_temp & " ]")
        Next i

        PACNET.UART.Close(hPort)
    End Sub

    Private Sub button_readAI_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_readAI.Click

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim f_AIValue As Single = 0

        Dim i_slot As Integer = Convert.ToInt16(comboBox_slot.Text)
        Dim i_port As Integer = Convert.ToInt16(comboBox_port.Text)
        Dim i_readChannel As Integer = Convert.ToInt16(textBox_channelNum.Text)
        Dim i_totalChannel As Integer = Convert.ToInt16(textBox_totalChannel.Text)
        Dim ba_temp(19) As Byte

        PACNET.PAC_IO.ReadAI(hPort, PACNET.PAC_IO.PAC_DAISY_CHAIN_WIRING_MODULE_PORT(i_slot, i_port), i_readChannel, i_totalChannel, f_AIValue)
        textBox_AIValue.Text = f_AIValue.ToString()

        PACNET.PAC_IO.ReadAISensorSerialNumber(hPort, i_slot, i_port, i_readChannel, ba_temp, 20)
        textBox_sersorSN.Text = System.Text.Encoding.Default.GetString(ba_temp, 0, 20)

        PACNET.UART.Close(hPort)

    End Sub
End Class
