// 87k_wdt_statusDlg.cpp : implementation file
//

#include "stdafx.h"
#include "string.h"
#include "87k_wdt_status.h"
#include "87k_wdt_statusDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMy87k_wdt_statusDlg dialog

CMy87k_wdt_statusDlg::CMy87k_wdt_statusDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy87k_wdt_statusDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy87k_wdt_statusDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMy87k_wdt_statusDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON2, &CMy87k_wdt_statusDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CMy87k_wdt_statusDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CMy87k_wdt_statusDlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, &CMy87k_wdt_statusDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, &CMy87k_wdt_statusDlg::OnBnClickedButton6)
END_MESSAGE_MAP()


// CMy87k_wdt_statusDlg message handlers

BOOL CMy87k_wdt_statusDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CMy87k_wdt_statusDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_MY87K_WDT_STATUS_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_MY87K_WDT_STATUS_DIALOG));
	}
}
#endif


void CMy87k_wdt_statusDlg::OnBnClickedButton2()
{
    // TODO: b[JiBz`{X
    HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    CString strTemp;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set WTD Timeout
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int WTDTimeout = _wtoi(temp);

    //use pac_SetModuleWDTConfig function
    BOOL iret = pac_SetModuleWDTConfig(hPort, slot, 1, WTDTimeout, 0);
	printf("error = 0x%X   \n\r",pac_GetLastError());
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Config WDT error", L"87k_wdt_status", MB_OK);
    }}

void CMy87k_wdt_statusDlg::OnBnClickedButton3()
{
    // TODO: Add your control notification handler code here
    HANDLE hPort = uart_Open("");
    TCHAR temp[20];

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    short ebStatus;
    ulong WTDTimeout;
    int WTDOverwrite;
    //use pac_GetModuleWDTConfig function
    BOOL iret = pac_GetModuleWDTConfig(hPort, slot, &ebStatus, &WTDTimeout, &WTDOverwrite);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Get Module WDT Config error", L"87k_wdt_status", MB_OK);
    }
    else
    {
        wsprintf(temp, L"%u", WTDTimeout);
        SetDlgItemText(IDC_EDIT1, temp);
    }}

void CMy87k_wdt_statusDlg::OnBnClickedButton4()
{
    // TODO: b[JiBz`{X
    HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    CString strTemp;
    float fValue = 0.0;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //use pac_SetModuleWDTConfig function
    BOOL iret = pac_ResetModuleWDT(hPort, slot);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Reset Module WDT error", L"87k_wdt_status", MB_OK);
    }}

void CMy87k_wdt_statusDlg::OnBnClickedButton5()
{
    // TODO: b[JiBz`{X
    HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    CString strTemp;
    float fValue = 0.0;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //use pac_SetModuleWDTConfig function
    BOOL iret = pac_RefreshModuleWDT(hPort, slot);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Refresh Module WDT error", L"87k_wdt_status", MB_OK);
    }
}

void CMy87k_wdt_statusDlg::OnBnClickedButton6()
{
		WORD Status;
		TCHAR temp[20];

		//get user set address
		HANDLE hPort = uart_Open("");
		GetDlgItemText(IDC_COMBO1, temp, 20);
		int slot = _wtoi(temp);

		Status = pac_GetModuleLastOutputSource(hPort, slot);
		if(Status == 0)
		{
			wsprintf(temp, L"Disable");
		}
		else if(Status == 2)
		{
			wsprintf(temp, L"Enable");
		}
		else if(Status == -1)
		{
			wsprintf(temp, L"CMD Time Out");
		}
		SetDlgItemText(IDC_EDIT2, temp);
		uart_Close(hPort);
}
