// pac_i8174W_FR_2024AO.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include "..\Lib\pac_i8172W.h"
#pragma comment(lib,"..\\Lib\\pac_i8172W.lib")


#include "stdafx.h"
#include <stdio.h>
#include "..\Lib\pac_i8172W.h"
#pragma comment(lib,"..\\Lib\\pac_i8172W.lib")

static int slotIndex=-1;
int _tmain(int argc, _TCHAR* argv[])
{
	int slot = -1,iRet=0;
	int diData,group,i,channel,mode,status,port,doData,bitVal,format,typeCode;
	float fval;
	for(slot=0;slot<8;slot++)
	{
	
		if(pac_i8172W_Init(slot)==0)
		{
			slotIndex=slot;			
			break;
		}
	}
	if(slotIndex==-1)
	{
		printf("There is no i8172W at Backplane\n");
		getchar();
		exit(0);
	}
	else
	{
		printf("There is an i8172W at slot %d\n",slotIndex);
	}	
	printf("Please input the port number of i-8172W 0 or 1:");
	scanf("%d",&port);
	printf("Please input the group index of FR-2057 0~7 :");
	scanf("%d",&group);
    printf("\nPlease input bit mode:\n");
	printf("12 : 12-bit mode \n");
	printf("16 : 16-bit mode \n");
    scanf("%d",&mode);
	
	printf("Please input the number of output channel for i-8172W 0 ~ 3");
	scanf("%d",&channel);
	
	printf("FR_2017 type code\n");
	printf("0 / 0x30	0 ~ 20 mA\n");
	printf("1 / 0x31	4 ~ 20 mA\n");
	printf("2 / 0x32	0~10 V\n");
	printf("3 / 0x33	+/-10V\n");
	printf("4 / 0x34	+/-1 V\n");
	printf("5 / 0x35	+/-5 V\n");  
	printf("\nPlease slect type code for FR-2017");
	scanf("%d",&typeCode);

	printf("Please input output value \n");
	scanf("%d",&fval);
	pac_i8172W_WriteAOFloat(slotIndex,port,group,mode,channel, typeCode,fval, 0);

	getchar();

	return 0;
}